# Компонент для профилирования с помощью xhprof

## Установка
### Composer
В `composer.json`, в секцию `repositories`, добавить:
```
"gitlab.iwayex.com/45": {
    "type": "composer",
    "url": "https://gitlab.iwayex.com/api/v4/group/45/-/packages/composer/packages.json"
}
```

Установить пакет:
```bash
$ composer require iwaydev/yii2-xhprof
```

### Dockerfile
```
# XHProf
RUN pecl install xhprof-2.3.9
RUN mkdir /var/log/xhprof
RUN chmod 777 /var/log/xhprof

# Graphviz
RUN apt-get install -y graphviz
```

## Настройка
### Nginx
```
server {
    listen 80;

    server_name prof.dynamic-price-service.local;
    charset utf-8;

    root /var/www/dynamic-price-service/vendor/pbweb/xhprof/xhprof_html;
    index index.php;

    location / {
#         auth_basic "Administrator’s log Area";
#         auth_basic_user_file /etc/nginx/auth.basic;
        try_files $uri $uri/ /index.php?q=$uri&$args;
    }

    location ~ \.php$ {
        include fastcgi_params;
        fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
        fastcgi_pass php:9000;
        try_files $uri =404;
    }
}
```
### Yii2 application
В точке входа, в `config/main.php` добавить:
```
    'bootstrap' => [
        'xhprof'
    ],
    'components' => [
        'xhprof' => [
            'class' => \iwaydev\yii2\profiler\components\XhprofComponent::class,
        ],
    ],
```
Настройки `XhprofComponent`:

| Attribute          | Type     | Description                                                                      | Default    |
|--------------------|----------|----------------------------------------------------------------------------------|------------|
| `enable`           | `bool`   | Включен или отключен                                                             | `true`     |
| `getParameterName` | `string` | Имя GET-параметра.  Если в GET-параметре передан `true`, то запустится профайлер | `profiler` |
| `auto`             | `bool`   | Запускать ли профайлер автоматом для всех запросов                               | `true`     |
